/* ==================================================== */
/*	Copyright (c) Atelier de BioInformatique	*/
/*	Mar. 92 					*/
/* 	File: libstki.h					*/
/*	History:					*/
/*	00/03/92 : <Gloup> first draft			*/
/*	07/07/93 : <Gloup> complete revision		*/
/*	10/03/94 : <Gloup> added xxxVector funcs	*/
/* ==================================================== */

#ifndef _H_Gtypes
#include "/home/aboxy/domi/structures_secondaires/LibTypes/Gtypes.h"
#endif

#define _H_libstki

/* ==================================================== */
/* Constantes de dimensionnement			*/
/* ==================================================== */

#ifndef kMinStackiSize
#define kMinStackiSize		4	/* taille mini stack	*/
#endif


#define kStkiNoErr		0	/* ok 			*/
#define kStkiMemErr		1	/* not enough memory	*/

#define kStkiReset		Vrai
#define kStkiGet		Faux

/* ==================================================== */
/* Macros standards					*/
/* ==================================================== */

#ifndef NEW
#define NEW(typ)		(typ*)malloc(sizeof(typ))
#define NEWN(typ, dim) 		(typ*)malloc((unsigned long) (dim) * sizeof(typ))
#define REALLOC(typ, ptr, dim)	(typ*)realloc((void *) (ptr), (unsigned long)(dim) * sizeof(typ))
#define FREE(ptr)		free((Ptr) ptr)
#endif


/* ==================================================== */
/*  Types & Structures de donnees			*/
/* ==================================================== */

						/* -------------------- */
						/* structure : pile	*/
						/* -------------------- */
typedef struct {
						/* ---------------------*/
	Int32			size;		/* stack size		*/
	Int32			top;		/* current free pos.	*/
	Int32			cursor;		/* current cursor	*/
	Int32			*val;		/* values 		*/
						/* ---------------------*/
} Stacki, *StackiPtr, **StackiHdle;	 



/* ==================================================== */
/*  Prototypes (generated by mproto)			*/
/* ==================================================== */

					/* libstki.c 	*/
					
Int16 	  	StkiError	   P((  Bool	   reset			));
StackiPtr 	NewStacki 	   P((	Int32      size 			));
StackiPtr 	FreeStacki 	   P((	StackiPtr  stki 			));
StackiHdle	NewStackiVector    P((  Int32 vectSize,   Int32 stackSize	));
StackiHdle	FreeStackiVector   P((  StackiHdle stkh,  Int32 vectSize     	));
Int32 	  	ResizeStacki 	   P((	StackiHdle stkh , Int32 size 		));
Bool 	  	PushiIn 	   P((	StackiHdle stkh , Int32 val 		));
Bool 	  	PopiOut 	   P((	StackiHdle stkh , Int32 *val 		));
Bool 	  	ReadiDown 	   P((	StackiPtr  stki , Int32 *val 		));
Bool 	  	ReadiUp 	   P((	StackiPtr  stki , Int32 *val 		));
void 	  	CursiToTop 	   P((	StackiPtr  stki 			));
void 	  	CursiToBottom      P((	StackiPtr  stki 			));
void 	  	CursiSwap 	   P((	StackiPtr  stki 			));
Bool 	  	SearchDownStacki   P((	StackiPtr  stki  , Int32 sval 		));
Bool 	  	BinSearchStacki    P((	StackiPtr  stki  , Int32 sval 		));
Bool 	  	SameStacki 	   P((	StackiPtr  stki1 , StackiPtr stki2 	));
Bool 	  	ReverseStacki      P((	StackiPtr  stki 			));    
