/* programme CherStr2						*/
/* isole toutes les solutions (ensembles de palindromes		*/
/* compatibles) de chaque sequence 				*/
/* code chaque solution et recherche la solution qui est	*/
/* repetee au moins une fois dans chaque sequence		*/
 /* Dominique BOUTHINON Decembre 1994				*/


#include <stdlib.h>
#include <stdio.h>
#include "pals3.c"

#define LONGSEQ  81
#define NBEXEMP 4
#define MAXNOM 30
#define SCOREMAX 80
#define MAXSEQ 20
#define MAXPALSOL 17
#define K 30



/* types   */

typedef
   unsigned char  ChainePals[MAXPALSOL] ;

typedef
   ChainePals Solu1Seq[K] ;


/* prototypes */


void InitScores(int Scores[][2])
/* initialise le tableau des K meilleurs scores */
{
 int i ;

 for (i = 0 ; i < K ; i++)
     Scores[i][0] = 0 ;
}


char *CoderUneSolution(Palindrome Pals[], Solution S)
/* Etablit la correspondance entre une solution et son code structurel */
{
 char Code[MAXPALSOL]   ;
 char Chaine[MAXPALSOL] ;
 int  Compteur= 0       ;
 int  p,p1	        ;
 int  q                 ;
 int  x 		;


 Code[0] = '\0' ;
 for (p = S.NS - 2 ; p >= 0 ; p--) {
     Compteur = 0 ;
     q = Pals[S.Sol[p]].Dqueue ;
     p1 = p + 1 ;
    while (p1 <= S.NS-1 &&  q > Pals[S.Sol[p1]].Dtete) {
	   Compteur ++ ;
	   if (q > Pals[S.Sol[p1]].Dqueue)
	      Compteur ++ ;
	   p1++ ;
     }
     /* incremente arbitrairement de 1 pour eviter une valeur nulle */
     Compteur++ ;
     if (strlen(Code) + 1 < MAXPALSOL) {
         sprintf(Chaine,"%d",Compteur) ;
	strcat(Code,Chaine) ;
     }
     else {
	  printf("PROBLEME DE TAILLE PENDANT CODAGE !!!\n\r") ;
	  scanf("%d",&x) ;
     }
 }
 return Code ;
}


void CoderLesSolutions(int NSeq,Palindrome Pals[],
		       TES *ES, int NES,Solu1Seq *Solu[],
		       int NbSol[])
/* etablit la correspondance entre chaque solution d'une sequence  	*/
/* et un code qui represente sa structure				*/

{
  int i ;

  Solu[NSeq] = (Solu1Seq*) malloc(sizeof(Solu1Seq)) ;
  if (Solu[NSeq] == NULL) {
     printf("probleme de memoire sequence %d\n\r",NSeq) ;
     scanf("%d",&i) ;
  }
  for (i = 0 ; i < NES ; i++)
      strcpy((*Solu[NSeq])[i],CoderUneSolution(Pals,(*ES)[i])) ;
  NbSol[NSeq] = NES ;

}



void AfficherSolutions(int Nseq, int NbSol[], Solu1Seq *Solu[])
/* Affiche le code correspondant a chaque solution des sequences */
{
 int i ;
 int j ;

 for (i = 0 ; i < Nseq ; i ++) {
     fprintf(stdout,"\n\r\n\rSequence %d\n\r",i) ;
     for (j = 0 ; j < NbSol[i] ; j++) {
	 fprintf(stdout,"%s ; ",(*Solu[i])[j]) ;
	 if (j > 0 && j%10 == 0)
	    fprintf(stdout,"\n\r") ;
     }
 }
}



void CherchePremiereSolutionRepetee (int n, int NbSol[],
				     Solu1Seq *Solu[])
/* cherche la premiere solution repete dans chaque sequence */
{
  int fin 	 ;
  int fin1 	 ;
  int fin2 	 ;
  int k		 ;
  int i		 ;
  int j		 ;
  ChainePals ChercheSol ;

  fprintf(stdout,"\n\rRecherche des solutions en cours...\n\r") ;
  fin = 0 ;
  k = 0 ;
  while (!fin && k < NbSol[0]) {
	/* pour toutes les solutions de la premiere sequence	   	  */
	strcpy(ChercheSol,(*Solu[0])[k]) ;
	/* fprintf(stdout,"Motif :%s\n\r",ChercheSol) ; */
	fin1 = 0 ;
	i = 1 ;
	while (!fin1 && i < n) {
	      /* de la 2eme a la derniere sequence			  */
	      /* fprintf(stdout,"                     %d\r",i) ; */
	      fin2 = 0 ;
	      j = 0 ;
	      while (!fin2 && j < NbSol[i]) {
		    /* pour toutes les solutions de la sequence en cours  */
		    if (strcmp((*Solu[i])[j],ChercheSol) == 0)
			fin2 = 1 ;
		    else
			j++ ;
	      }
	      if (!fin2)
		 /* on a pas trouve la structure dans la sequence en cours */
		 /* pas besoin d'explorer les autres sequences		   */
		 fin1 = 1 ;
	      else
		 i++ ;
	}
	if (fin1) {
	   /* echec pour trouver la structure => on pas a solution        */
	   /* suivante de la premiere sequence				  */
	   k++ ;
	   fprintf(stdout,"\n\r") ;
	}
	else
	   /* on a trouve la structure dans chaque sequence => ok         */
	   fin = 1 ;
  }
  if (fin) {
     printf("\n\rVoici la premiere solution repetee :\n\r") ;
     printf("%s\n\r",ChercheSol) ;
  }
  else
     printf("\n\rAucune solution repetee dans chaque sequence\n\r") ;

}


int CodeNonVu(Solu1Seq Solu0,int NbSol,Solu1Seq SoluVues,
		int *NbSoluVues,int *k)
/* cherche le premier code non encore envisage dans la sequence 0 	*/
{
   int i ;
   ChainePals SoluEnvisagee ;


   while (*k < NbSol) {
	 strcpy(SoluEnvisagee,Solu0[*k]) ;
	 i = 0 ;
	 while (i < *NbSoluVues && strcmp(SoluEnvisagee,SoluVues[i]) !=0 )
	       i++ ;
	if (i < *NbSoluVues)
	   /* deja envisagee */
	  (*k)++ ;
	else {
	   strcpy(SoluVues[*NbSoluVues],Solu0[*k]) ;
	   (*NbSoluVues) ++ ;
	   return *k ;
	}
   }
   return -1 ;
}





void ChercheToutesSolutionsRepetees (int n, int NbSol[],
				     Solu1Seq *Solu[K])
/* cherche toutes les solutions repetees dans chaque sequence */
{
  int fin 	            ;
  int fin1 	            ;
  int fin2 	            ;
  int k		            ;
  int i		            ;
  int j		            ;
  ChainePals ChercheSol     ;
  ChainePals SoluVues[K]    ;
  int        NbSoluVues = 0 ;

  fprintf(stdout,"\n\rRecherche des solutions en cours...\n\r") ;
  k = 0 ;
  while (CodeNonVu(*Solu[0],NbSol[0],SoluVues,&NbSoluVues,&k) >= 0) {
	/* pour toutes les solutions de la premiere sequence	   	  */
	strcpy(ChercheSol,(*Solu[0])[k]) ;
	/* fprintf(stdout,"Motif :%s,  numero %d\n\r",ChercheSol,k) ; */
	fin1 = 0 ;
	i = 1 ;
	while (!fin1 && i < n) {
	      /* de la 2eme a la derniere sequence			  */
	      /* fprintf(stdout,"                     %d\r",i) ;          */
	      fin2 = 0 ;
	      j = 0 ;
	      while (!fin2 && j < NbSol[i]) {
		    /* pour toutes les solutions de la sequence en cours  */
		    if (strcmp((*Solu[i])[j],ChercheSol) == 0)
			fin2 = 1 ;
		    else
			j++ ;
	      }
	      if (!fin2)
		 /* on a pas trouve la structure dans la sequence en cours */
		 /* pas besoin d'explorer les autres sequences		   */
		 fin1 = 1 ;
	      else
		 i++ ;
	}
	if (fin1) {
	   /* echec pour trouver la structure => on pas a solution        */
	   /* suivante de la premiere sequence				  */
	   /* printf("\n\rAucune solution repetee pour ce motif \n\r") ;  */
	   /* fprintf(stdout,"\n\r") ;					  */
	}
	else {
	   /* on a trouve la structure dans chaque sequence => ok         */
	   printf("\n\rVoici une solution repetee :\n\r") ;
	   printf("%s\n\r",ChercheSol) ;
	}
	k++ ;
  }

}


void LibereSolutions(int Nseq,  Solu1Seq *Solu[])
/* libere les emplacements memoires pris par les solutions		*/
{
   int i ;

   for (i = 0 ; i < Nseq ; i++)
       free(Solu[i]) ;
}



void PrintBestSolutions(char *Seq,Palindrome Pals[],
			TES *ES,int NES)
{
   int i        ;
   int j        ;
   int k,u        ;
   int k1       ;
   int longueur ;
   int seqlen   ;
   char Csolu[LONGSEQ-2] ;


   seqlen = strlen(Seq) ;
   for (i = 1 ; i <= seqlen ; i++)
	    if (i%10 == 0)
	       fprintf(stdout,"%1d",i/10) ;
	    else
	       fprintf(stdout," ") ;
	fprintf(stdout,"\n\r") ;
	for (i = 1 ; i <= seqlen ; i++)
	    fprintf(stdout,"%1d",i%10) ;
	fprintf(stdout,"\n\r") ;
   fprintf(stdout,"%s\n\r",Seq) ;
   for (u = 0  ; u < NES ; u++) {
   /* pour chaque meilleure solution */
       for (j = 0 ; j < LONGSEQ-2  ; j ++)
	   Csolu[j] = ' ' ;
       Csolu[LONGSEQ-3] = '\0' ;
       for (j = 0 ; j < (*ES)[u].NS ; j ++) {
       /* pour chaque palindrome d'une solution */
	  longueur = Pals[(*ES)[u].Sol[j]].Ftete -
		       Pals[(*ES)[u].Sol[j]].Dtete + 1 ;
	   k1 = Pals[(*ES)[u].Sol[j]].Dtete ;
	   Csolu[k1-1] = 48 + j ;
	   for (k = k1 + 1 ; k < Pals[(*ES)[u].Sol[j]].Dtete + longueur - 1 ; k++)
	       Csolu[k-1] = Seq[k-1] ;
	   Csolu[k-1] = 48 + j ;
	   k1 = Pals[(*ES)[u].Sol[j]].Dqueue ;
	   Csolu[k1-1] = 48 + j ;
	   for (k = k1 + 1 ; k < Pals[(*ES)[u].Sol[j]].Dqueue + longueur -1 ; k++)
	       Csolu[k-1] = Seq[k-1] ;
	   Csolu[k-1] = 48 + j ;
       }
       j = strlen(Csolu) ;
       while (Csolu[j] == ' ' || Csolu[j] == '\0')
	     j-- ;
       j++ ;
       Csolu[j] = '\0' ;
       fprintf(stdout,"%s :",Csolu) ;
       fprintf(stdout,"%d\n\r",(*ES)[u].Score) ;
   }
   fprintf(stdout,"\n\r") ;
}






void main ()
{
   Solu1Seq *Solu[MAXSEQ] ;
   Palindrome Modele[NBEXEMP] =
	      {
		{ 1, 7,66,72,0},
		{10,13,22,25,1},
		{27,31,39,43,1},
		{49,53,61,65,1}
	       }                ;
   Palindrome Pals[MAXPAL]      ;
   FILE *entree, *sortie   	;
   char Nentree[MAXNOM]    	;
   char Nsortie[MAXNOM]		;
   char Nc[3]              	;
   char Seq[LONGSEQ]       	;
   int  NbPals  	   	;
   int  i		   	;
   int  Nseq	           	;
   int  t			;
   int  Limite 			;
   int  ok			;
   TES *ES                      ;
   int  NES                     ;
   Solution S			;
   FILE *fichier		;
   int Scores[K][2]             ;
   int NbSol[MAXSEQ]	        ;
   Solution LaSolution		;
   int NseqLue			;

   /* debut du programme principal */
   printf("Nombre d'exemples ?\n") ;
   scanf("%d",&Limite) ;
    printf("Debut du programme\n\n") ;
   printf("Nom du fichier d'entree ?\n") ;
   scanf("%s",Nentree) ;
   entree = fopen(Nentree,"r") ;
   Nseq = 0 ;
   NseqLue = 0 ;
   NbPals = 0 ;
	while
	       (
		 Nseq < Limite &&
		 LireSeqExScore(&ok,entree,Modele,Pals,Seq, &NbPals,
				&LaSolution)
	       ) {
	    if (!ok) {
	      NseqLue++ ;
	      fprintf(stdout,"Sequence N %d\n\r",NseqLue) ;
	      ES = (TES*) malloc(sizeof(TES)) ;
	      if (!ES) {
		 printf("probleme de memoire !!! \n\r") ;
		 scanf("%d",&i) ;
	      }
	      InitScores(Scores) ;
	      NES = 0 ;
	      S.NS = 0 ;
	      MeilleursSolutions(K,NbPals,Pals,-1,S,ES,&NES,Scores) ;
	      /* PrintBestSolutions(Seq,Pals,ES,NES) ; */
	      CoderLesSolutions(Nseq,Pals,ES,NES,Solu,NbSol) ;
	      Nseq++ ;
	      free(ES) ;
	    }
	    else
	       NseqLue++ ;
	}
   fclose(entree) ;
   /*AfficherSolutions(Nseq,NbSol,Solu) ; */
   ChercheToutesSolutionsRepetees(Nseq,NbSol,Solu) ;
   LibereSolutions(Nseq,Solu) ;
   fprintf(stdout,"fin du programme\n") ;
} 
