/* ==================================================== */
/*	Copyright (c) Atelier de BioInformatique	*/
/*	Mar. 92 					*/
/* 	File: libkmr_pal.h				*/
/*	Purpose: KMR 'special DNA palindromes'	 	*/
/*	History:					*/
/*	00/03/92 : <Gloup> first draft			*/
/*	15/08/93 : <Gloup> revised version		*/
/* ---------------------------------------------------- */

#ifndef _H_libkmr_pal

#define _H_libkmr_pal

#ifndef _H_Gtypes
#include "Gtypes.h"
#endif

#ifndef _H_libstki
#include "libstki.h"
#endif

#ifndef _H_libstkp
#include "libstkp.h"
#endif


/* ==================================================== */
/* Constantes de dimensionnement			*/
/* ==================================================== */

/* ==================================================== */
/* Macros standards					*/
/* ==================================================== */

#ifndef NEW
#define NEW(typ)		(typ*)malloc(sizeof(typ)) 
#define NEWN(typ, dim) 		(typ*)malloc((unsigned long)(dim) * sizeof(typ))
#define REALLOC(typ, ptr, dim)	(typ*)realloc((void *) (ptr), (unsigned long)(dim) * sizeof(typ))
#define FREE(ptr)		free((Ptr) ptr)
#endif

/* ==================================================== */
/*  Types & Structures de donnees			*/
/* ==================================================== */

typedef struct {
	Int32	   minlen, maxlen;	/* min and max words length		*/
	StackiPtr  nbwords;		/* stack of # words foreach length	*/
	StackpPtr  words;		/* stack of pointers foreach length	*/
					/* each elt points to a stack of index	*/
} WordBunch, *WordBunchPtr, **WordBunchHdle;

/* ==================================================== */
/*  Prototypes (generated by bpro)			*/
/* ==================================================== */

				/* libkmr.c		*/
				
void	     SetUpKmrcNotify  P(( Bool notif ));

StackiHdle   FreeStackiVector P(( StackiHdle stkh,  Int32 vectSize 	));
StackiHdle   NewStackiVector  P(( Int32 vectSize,   Int32 stackSize	));
WordBunchPtr FreeWordBunch    P(( WordBunchPtr wb			));
WordBunchPtr NewWordBunch     P(( Int32 stackiSize, Int32 stackpSize	));

WordBunchPtr DoKmrPal	      P(( Int32 *data, Int32 N, Int32 M, 
				  Int32 minlen, Int32 maxlen, Int32 zone ));

#endif
