/* ====================================================================	*/
/*									*/
/*	Copyright (c) Atelier de BioInformatique			*/
/*	February 95.							*/
/* 	Fichier : LibKmrS.h						*/
/*	Objet	:							*/
/*		  fichier de declarations du source LibKmrS.c et        */
/*		  KmrsStr.c						*/
/*	Version : 10/02/95.						*/
/*									*/
/* ====================================================================	*/





/* ====================================================================	*/
/* 			definition des types				*/
/* ====================================================================	*/

typedef struct {
		Int32 DTete  ;	  /* position de la tete d'un pal	*/
		Int32 FTete  ;    /* position fin tete d'un pal		*/
		Int32 DQueue ;    /* position de la queue d'un pal	*/
		Int32 FQueue ;    /* position fin queue d'un pal	*/
		int   Code   ;    /* pure ou impure			*/
		Int32 Score  ;    /* score du palindrome		*/
	} TPal ;

typedef struct {
		Int32 Seq   ;     /* numero de sequence			*/
		Int32 Sol   ;	/* numero de solution			*/
		Int32 Pal   ;	/* numero de palindrome			*/
	} TPosition ;




/* ====================================================================	*/
/* 			definition des constantes			*/
/* ====================================================================	*/



/* ====================================================================	*/
/* 			definition des fonctions			*/
/* ====================================================================	*/
WordBunchPtr DoKmrS     P((
	int      f              ,    /* temoin sauvegarde dans fichier	*/
	int      Verbose	,    /* taux de bavardage		*/
	Int32        *va   	,    /* index des classes de taille 1	*/
	Int32      minlen       ,    /* taille minimale des structures  */
	Int32      maxlen   	,    /* taille maximale structures	*/
	Int32           k       ,    /* taille courante structures	*/
	Int32         *e   	,    /* Nb de classe de taille 1	*/
	Int32          n	,    /* nb total pals			*/
	Int32          N 	,    /* nb sequences			*/
	Int32        Rmin       ,    /* nb minimal de repetitions	*/
	Int32        * t 	,    /* nb solutions			*/
	Int32       ** p	,    /* nb Pals		        	*/
	TPosition    * Pos	,    /* indices Seq,Sol,Pal		*/
	TPal      ** Pal        ,    /* Palindromes			*/
	Int32    *** Sol	,    /* indices Pal dans Sol		*/
	Int32 	  **** M	     /* Matrices			*/
				)) ;   
