/* ====================================================================	*/
/*									*/
/*	Copyright (c) Atelier de BioInformatique			*/
/*	February 95.							*/
/* 	Fichier : libkmrs8.h						*/
/*	Objet	:							*/
/*		  fichier de declarations du source libkmrs6.c et       */
/*		  Kmrstr8.c						*/
/*	Version : Juillet 1995	   					*/
/*									*/
/* ====================================================================	*/





/* ====================================================================	*/
/* 			definition des constantes			*/
/* ====================================================================	*/

#define NBATTRIBUTS 6



/* ====================================================================	*/
/* 			definition des types				*/
/* ====================================================================	*/



typedef struct 
        {
		Int32 Seq   ;   /* numero de sequence			*/
		Int32 Sol   ;	/* numero de solution			*/
		Int32 Pal   ;	/* numero de palindrome			*/
	} 
                TPosition   ;




/* ====================================================================	*/
/* 			definition des constantes			*/
/* ====================================================================	*/


/* ====================================================================	*/
/* 			definition des fonctions			*/
/* ====================================================================	*/

WordBunchPtr DoKmrS P((
        int    Dtrna            ,    /* nb bases avant et apres TRNA    */
        int    check            ,    /* distribution structure 6000     */
        int    td1              ,    /* temoin calcul distance 1        */
	int    *** d1           ,    /* tableau distances 1             */
        int    td2              ,    /* temoin calcul distance 2        */
	int    *** d2           ,    /* tableau distances 2             */
        int    td3              ,    /* temoin calcul distance 3        */
	int    *** d3           ,    /* tableau distances 3             */
	int    Ecart		,    /* temoin calcul ecart type	*/
	int    Moyenne		,    /* temoin affichage nb moyen de 	*/
				     /* de sol contenant une structure	*/
	int      lt		,    /* temoin tenir compte des tetes   */
	int    **VTete		,    /* tab des tetes des pals		*/
	int      lb		,    /* temoin tenir compte boucles	*/
	int    **VBoucle	,    /* tab des boucls des pals		*/
	int	purete		,    /* temoin tenir compte purete pal	*/
	int      st             ,    /*  temoin sauvegarde taux         */
	Int32    Fic[]          ,    /*  nb structures long 0..5        */
	Int32    SFic[]         ,    /*  nb structures long <=0 ..<= 5  */
	Int32    Tstruct[]      ,    /* tableau taux de chaque structur */
	int      f              ,    /* temoin de sauvegarde            */
	int      Verbose        ,    /* taux de blabla...               */
	Int32    va[]           ,    /* index des classes de taille 1   */
	Int32      minlen       ,    /* taille minimale des structures  */
	Int32      maxlen       ,    /* taille maximale structures      */
	Int32           k       ,    /* taille courante structures      */
	Int32         *e        ,    /* Nb de classe de taille 1        */
	Int32          n        ,    /* nb total pals                   */
	Int32          N        ,    /* nb sequences                    */
	Int32      Rmin         ,    /* nb minimal de repetitions       */
	Int32        * t        ,    /* nb solutions                    */
	Int32       ** p        ,    /* nb Pals                         */
	TPosition    * Pos      ,    /* indices Seq,Sol,Pal             */
	Palindrome  ** Pal      ,    /* Palindromes                     */
	Int32    *** Sol        ,    /* indices Pal dans Sol            */
	Int32     **** M             /* Matrices                        */

                      )) ;
