/* ==================================================== */
/* Gloup Mar. 92 					*/
/* Copyright (c) Atelier de BioInformatique		*/
/* @file: libset.h					*/
/* ==================================================== */

#ifndef _H_Gtypes

#include "../../Include/gtypes.h"

#endif

#define _H_libset

/* ==================================================== */
/* constantes						*/
/* ==================================================== */

#define kUn		0xffffffff  	/*  all bits set in a long	*/

/* ==================================================== */
/* Macros						*/
/* ==================================================== */

#ifndef NEW

#define NEW(object)		(object*)malloc(sizeof(object)) 
#define NEWN(object, dim) 	(object*)malloc((unsigned)(dim) * sizeof(object))
#define FREE(object)		free(object)

#endif


/* ==================================================== */
/*  Types & Structures de donnees			*/
/* ==================================================== */
							
					/* -------------------- */
					/* structure : Set	*/
					/* -------------------- */
typedef struct s_Set {
	Int32	 	dim;
	Int32		size;
	ULong 		*bits;
} Set, *SetPtr;

/* ==================================================== */
/*   Prototypes (generated by mproto)			*/
/* ==================================================== */

					/* from libset.c */
SetPtr  NewSet 		P((Int32 dim ));
void 	FreeSet 	P((SetPtr E ));
void 	AddElt 		P((SetPtr E , Int32 x ));
void 	RemElt 		P((SetPtr E , Int32 x ));
void 	CopySet 	P((SetPtr F , SetPtr E ));
void 	EmptySet 	P((SetPtr E ));
void 	UnionSet 	P((SetPtr U , SetPtr E , SetPtr F ));
void 	InterSet 	P((SetPtr I , SetPtr E , SetPtr F ));
void 	ComplemSet 	P((SetPtr E ));
Bool 	IsEmptySet 	P((SetPtr E ));
Bool 	IsIncluded 	P((SetPtr E , SetPtr F ));
Bool 	BelongSet 	P((SetPtr E , Int32 x ));
Int32 	CardSet 	P((SetPtr E , Int32 x ));
void 	PrintSet 	P((FILE *stream , SetPtr E ));   
