/* ==================================================== */
/*	Copyright (c) Atelier de BioInformatique	*/    
/*	Mar. 92 					*/
/* 	File: libstkp.h					*/
/*	History:					*/
/*	00/03/92 : <Gloup> first draft			*/
/*	07/07/93 : <Gloup> complete revision		*/
/*	10/03/94 : <Gloup> added xxxVector funcs	*/
/* ==================================================== */

#ifndef _H_Gtypes

#include "gtypes.h"

#endif

#define _H_libstkp

/* ==================================================== */
/* Constantes de dimensionnement			*/
/* ==================================================== */

#ifndef kMinStackpSize
#define kMinStackpSize		2	/* taille mini stack	*/
#endif


#define kStkpNoErr		0	/* ok 			*/
#define kStkpMemErr		1	/* not enough memory	*/

#define kStkpReset		Vrai
#define kStkpGet		Faux

/* ==================================================== */
/* Macros standards					*/
/* ==================================================== */

#ifndef NEW
#define NEW(typ)		(typ*)malloc(sizeof(typ)) 
#define NEWN(typ, dim) 		(typ*)malloc((unsigned long)(dim) * sizeof(typ))
#define REALLOC(typ, ptr, dim)	(typ*)realloc((void *) (ptr), (unsigned long)(dim) * sizeof(typ))
#define FREE(ptr)		free((Ptr) ptr)
#endif


/* ==================================================== */
/*  Types & Structures de donnees			*/
/* ==================================================== */

						/* -------------------- */
						/* structure : pile	*/
						/* -------------------- */
typedef struct {
						/* ---------------------*/
	Int32			size;		/* stack size		*/
	Int32			top;		/* current free pos.	*/
	Int32			cursor;		/* current cursor	*/
	Ptr			*val;		/* values 		*/
						/* ---------------------*/
} Stackp, *StackpPtr, **StackpHdle;	 


/* ==================================================== */
/*  Prototypes (generated by mproto)			*/
/* ==================================================== */

					/* libstkp.c 	*/
					
Int16 	  	StkpError	   P((  Bool	   reset			));
StackpPtr 	NewStackp 	   P((	Int32      size 			));
StackpPtr 	FreeStackp 	   P((	StackpPtr  stkp 			));
StackpHdle	NewStackpVector    P((  Int32 vectSize,   Int32 stackSize	));
StackpHdle	FreeStackpVector   P((  StackpHdle stkph, Int32 vectSize	));
Int32 	  	ResizeStackp 	   P((	StackpHdle stkh , Int32 size 		));
Bool 	 	PushpIn 	   P((	StackpHdle stkh , Ptr    val 		));
Bool 	  	PoppOut 	   P((	StackpHdle stkh , Ptr   *val 		));
Bool 	  	ReadpDown 	   P((	StackpPtr  stkp , Ptr   *val 		));
Bool 	  	ReadpUp 	   P((	StackpPtr  stkp , Ptr   *val 		));
void 	  	CurspToTop 	   P((	StackpPtr  stkp 			));
void 	  	CurspToBottom      P((	StackpPtr  stkp 			));
void 	  	CurspSwap 	   P((	StackpPtr  stkp 			));
Bool 	  	SearchDownStackp   P((	StackpPtr  stkp  , Ptr  sval 		));
Bool 	  	ReverseStackp      P((	StackpPtr  stkp 			));    
