/* ==================================================== */
/*	Copyright (c) Atelier de BioInformatique	*/
/*	Mar. 92 					*/
/* 	File: libsys.h					*/
/*	History:					*/
/*	00/03/92 : <Gloup> first draft			*/
/*	07/07/93 : <Gloup> complete revision		*/
/* ==================================================== */

#ifndef _H_libsys

#define _H_libsys

#ifndef _H_Gtypes
#include "Gtypes.h"
#endif

/* ==================================================== */
/* Constantes						*/
/* ==================================================== */

#define TICKS_PER_SEC	60

#define TIME_RESET	Vrai
#define TIME_NO_RESET	Faux

/* ==================================================== */
/* Macros standards					*/
/* ==================================================== */

#ifndef NEW
#define NEW(typ)		(typ*)malloc(sizeof(typ)) 
#define NEWN(typ, dim) 		(typ*)malloc((unsigned long)(dim) * sizeof(typ))
#define REALLOC(typ, ptr, dim)	(typ*)realloc((void *) (ptr), (unsigned long)(dim) * sizeof(typ))
#define FREE(ptr)		free((Ptr) ptr)
#endif

#ifndef BANNER
#define BANNER(msg)		fprintf(stderr, msg)
#define FMTBANNER(fmt, msg)	fprintf(stderr, fmt, msg)
#endif

/* ==================================================== */
/*  Prototypes (generated by mkproto)			*/
/* ==================================================== */

					/* libsys.c 	*/
					
float	UserCpuTime	P((	Bool reset	));
float	SysCpuTime	P((	Bool reset	));
char	*StrCpuTime	P((	Bool reset	));

void	AbiBanner	P(( char *progname, char *version, char *timestamp, char *hostname ));

#endif
