/* ------------------------------------- */
/* fichier shuffleC2.c			 */
/* programme pour permutter des sequenc. */
/* en conservant enventuellement des	 */
/* morceaux en 5' et 3'			 */
/* -n<entier> :  nombre de sequences	 */
/*               aleatoires / seq bio	 */
/* -k	      :  permutation dans 	 */
/*               partie degeneree	 */
/* -c         :  commentaire debut seq   */
/* ------------------------------------- */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>    
#include <time.h>

#include "../../include/param.h"
#include "../../include/gtypes.h"
#include "../../include/libsys.h"

#define MAX_RND 0x7fffffff      /* plus grand entier aleatoire		*/
#define NB_BASES 50	   	/* nb base sur une ligne		*/
#define LONG 1000		/* longueur max d'une sequence		*/
#define LINE_FEED 10		/* retour chariot			*/
#define ALPHABET "ACGTNU-"	


static void ARGUMENT(int* a, char b, char c[])
{
     if (c[0] != '0') 
     {
          *a = atoi(c) ;
          if (!a) 
          {
		fprintf(stderr,"Mauvais argument -%c %s\n",b,c); 
                exit(0) ;
	  }
     }
}




static void Permutte(int part1, int part2, char Seq[], int LongSeq) 
{

					/* echange position i et j	*/
					
   int i             ;   		
   int j             ; 	 
   int aux	     ; 		
           
       

   for (i = part1 ; i <= part2 ; i++)
   {

					/* tirage au sort de la base  	*/
					/* entre i et part2		*/
						
	j = (int) (i + 1.0 * (part2 - i) * (random() - 0)  / (MAX_RND-0)) ;   
	
					/* echange des valeurs		*/
					
	aux    = Seq[i] ;
	Seq[i] = Seq[j] ;
	Seq[j] = aux	;
			
   }
   
    
}




main(int argc, char * argv[])  
{
 char   rien[10]        ;
 int 	LongSeq 	; /* longueur des sequences			*/
 char   Seq[LONG]	; /* sequence originale				*/
 int    j		; /* indice de base				*/
 char 	c		; /* base					*/	 
 char   Symb            ; /* symbole argument de main 			*/
 char   Argument[50]    ; /* argument de main	     			*/
 int    N = 0		; /* nb de sequences				*/
 int    Longueur        ;
 int    repetition = 5	; /* nb sequences shufflees par sequence bio	*/
 int    r		; /* indice de repetition d'une meme sequence	*/
 int    NSorties = 0    ; /* nb sequences en sortie			*/
 char*  base		; /* caractere lu est une base			*/
 int    part1  	  = -1	; 
 int 	part2 	  = -1 	;
 int    Debut = -1	;   /* debut partie variable			*/
 int    Fin   = -1      ;   /* fin partie variable			*/

  fprintf(stderr,"debut du programme shuffle \n")   ;
   
					/* Initialisation		*/
  srandom((int)time(NULL)) ;
     
  while (SelectArg("-n",&Symb,Argument,argc,argv)) 
  {
	  switch (Symb) 
          {
		 case 'n' : ARGUMENT(&repetition,Symb,Argument)      ;
			    break	                             ;			 		  
	  }
  }


 fprintf(stderr,"nombre de repetitions %d\n",repetition) ; 

 
 while (!feof(stdin))
  {
						/* lecture de la sequence courante	*/
	LongSeq   = 0 ;
	Longueur  = 0 ;

	fscanf(stdin,"%d",&LongSeq) ;
	fflush(stdin) ;
	
	fprintf(stderr,"Longueur = %dx", LongSeq) ;	       	

	while (Longueur < LongSeq)
	{
	 	fscanf(stdin,"%c",&c)  ;
		fflush(stdin) ;
	        fprintf(stderr,"%c",c) ;		
		base = strchr(ALPHABET,c) ;

		if (base)
		{ 
		  Seq[Longueur] = c ; 			 		
		  Longueur++        ; 		  
		}
     	 								
	}
		
	if (Longueur)
	{
	    if (c != LINE_FEED)	   
	        fscanf(stdin,"%c", &c) ;
	        	      	   
	    fscanf(stdin,"%c",&c)	;
	    fscanf(stdin,"%c",&c)	;
	    		
	    				 /* lecture du # */	
	    N++ ;
	    fprintf(stderr,"%d\n",N) ;
 
            
		part1 = 0           ;
		part2 = Longueur -1 ;
            

	    for (r = 1 ; r <= repetition ; r++)
	    {
	   	Permutte(part1, part2, Seq, Longueur) ;

				/* ecrit la nouvelle sequence	*/

		fprintf(stdout,"%d\n",Longueur)                        ;   
  
                
		for (j = 1  ; j <= Longueur ; j++)
		{
			fprintf(stdout,"%c",Seq[j-1])            ;
			if ((j % NB_BASES) == 0) 
	           		fprintf(stdout,"\n") ;
		}
	
		if ((Longueur % NB_BASES) != 0) 
	        	fprintf(stdout,"\n") ;		               

		fprintf(stdout,"#\n") ;

	        NSorties++ ;
	    }
	}
 }

  fprintf(stderr,"nombre de sequences traitees  : %d\n",N) ;
  fprintf(stderr,"nombre de sequences en sortie : %d\n", NSorties) ;
  fprintf(stderr,"fin du programme\n") ;	

  return 1 ;
}

