 /*
	      posrscript output for secondary structures
		    and pair probability matrices
				   
		 c Ivo L Hofacker and Peter F Stadler
			  Vienna RNA package

		Version modifiee par Dominique Bouthinon
*/
		/* integre au programme KMRSTR8				*/


/*Last changed Time-stamp: 29 Avril 1998  */
#include <stdio.h>
#include <math.h>
#include <string.h>


#define  PRIVATE   static
#define  MAX(A,B)    (A)>(B)?(A):(B)
#define  PI       3.141592654  
#define  PIHALF       PI/2.


/*--------------------------------------------------------------------------*/

void PS_dot_plot(char* Titre, char *string, float** pair, char *wastlfile) 
{
   FILE *wastl;
   int i, j ;
   int length; 
   double tmp,scale;
   
 
   length= strlen(string);
   wastl = fopen(wastlfile,"w");
   if (wastl==NULL) 
      fprintf(stderr,"can't open file for dot plot\n");
  

   
   fprintf(wastl,"%%!PS-Adobe-2.0 EPSF-1.2\n");
   fprintf(wastl,"%%%%Title: RNA DotPlot\n");
   fprintf(wastl,"%%%%Creator: RNAfold V.01.002c  - by Oymolon\n");
   fprintf(wastl,"%%%%BoundingBox: 66 211 518 662\n");
   fprintf(wastl,"%%%%Pages: 1\n");
   fprintf(wastl,"%%%%EndComments: blah blah...\n\n");
   
   fprintf(wastl,"%%This file contains "
	   "the base pair probabilities in the form\n");
   fprintf(wastl,"%% i  j  pair(i,j) ubox\n\n");

			/* affichage du titre		   */

  fprintf(wastl,"/Helvetica findfont\n")  ;
  fprintf(wastl,"14 scalefont setfont\n") ;
  fprintf(wastl,"75 200 moveto\n") ;
  fprintf(wastl,"(%s) show\n\n", Titre) ;

			/* matrice triangulaire superieure */

   fprintf(wastl,"/ubox {\n");     
   fprintf(wastl,"   /s exch def\n");
   fprintf(wastl,"   exch len exch sub 1 add box\n");
   fprintf(wastl,"} def\n\n");

			/* matrice triangulaire inferieure */	
		
   fprintf(wastl,"/lbox {\n");     
   fprintf(wastl,"   /s exch def\n");
   fprintf(wastl,"   len exch sub 1 add box\n");
   fprintf(wastl,"} def\n\n");

   fprintf(wastl,"/box {\n");
   fprintf(wastl,"   newpath\n");
   fprintf(wastl,"   moveto\n");
   fprintf(wastl,"   0.5 s mul   0 rlineto\n");
   fprintf(wastl,"   0   0.5 s mul rlineto\n");
   fprintf(wastl,"  -1 s mul     0 rlineto\n");
   fprintf(wastl,"   0    -1 s mul rlineto\n");
   fprintf(wastl,"   1 s mul     0 rlineto\n");
   fprintf(wastl,"   0   0.5 s mul rlineto\n");
   fprintf(wastl,"   closepath\n");
   fprintf(wastl,"   fill\n");
   fprintf(wastl,"   stroke\n");
   fprintf(wastl,"} def\n");
   fprintf(wastl,"\n");
   fprintf(wastl,"/sequence { (%s) } def\n", string);
   fprintf(wastl,"/len { sequence length } def\n\n");
  
 
   fprintf(wastl,"72 216 translate\n");
   scale = 72.0*6.0/((double)length);
   fprintf(wastl,"%f %f scale\n",scale,scale);
   fprintf(wastl,"/Times-Roman findfont 0.95 scalefont setfont\n\n");

   fprintf(wastl,"0 1 len 1 sub {\n");
   fprintf(wastl,"    dup\n");
   fprintf(wastl,"    0.7 add -0.3 moveto\n");
   fprintf(wastl,"    sequence exch 1 getinterval\n");
   fprintf(wastl,"    show\n");
   fprintf(wastl,"} for\n");
   fprintf(wastl,"\n");
   fprintf(wastl,"0 1 len 1 sub {\n");
   fprintf(wastl,"    dup\n");
   fprintf(wastl,"    0.7 add 0.7 len add moveto\n");
   fprintf(wastl,"    sequence exch 1 getinterval\n");
   fprintf(wastl,"    show\n");
   fprintf(wastl,"} for\n\n");

   fprintf(wastl,"90  rotate\n");
   fprintf(wastl,"0 1 len 1 sub {\n");
   fprintf(wastl,"    dup\n");
   fprintf(wastl,"    0.7 add -0.2 moveto\n");
   fprintf(wastl,"    len 1 sub exch sub\n");
   fprintf(wastl,"    sequence exch 1 getinterval\n");
   fprintf(wastl,"    show\n");
   fprintf(wastl,"} for\n");
   fprintf(wastl,"270 rotate\n\n");

   fprintf(wastl,"270 rotate\n");
   fprintf(wastl,"0 1 len 1 sub {\n");
   fprintf(wastl,"    dup\n");
   fprintf(wastl,"    -0.3 add len sub  0.7 len add  moveto\n");
   fprintf(wastl,"    sequence exch 1 getinterval\n");
   fprintf(wastl,"    show\n");
   fprintf(wastl,"} for\n");
   fprintf(wastl,"90 rotate\n\n");

			/* trace la diagonale	*/

   fprintf(wastl,"0.04 setlinewidth\n"
	   " 0.5 %4.1f moveto %4.1f 0.5 lineto stroke \n\n",
          
	   length+0.5, length+0.5);


   fprintf(wastl,"0.01 setlinewidth\n"
	   "[0.2 0.8] 0.1 setdash\n"
	   "len 1.2 div log 1 sub cvi 10 exch exp\n"
	   "0.5 exch  0.5 len add {\n"
	   "   dup dup\n"
	   "   0.5 moveto\n"
	   "   len 0.5 add  lineto \n"
	   "   dup\n"
	   "   len 1 add exch sub 0.5 exch moveto\n"
	   "   len 0.5 add exch len 1 add exch sub lineto\n"
	   "} for\n"
	   "stroke\n\n");

   for (i = 0 ; i < length; i++)
       for (j = 0; j < length  ; j++)       
           fprintf(wastl,"%d %d %1.5f ubox\n", i+1, j+1, pair[i][j]); 
          

   fprintf(wastl,"showpage\n");
   fclose(wastl); 
}

