/* --------------------------------------------------------------------	*/
/* Sauvegarde des sequences, palindromes et positions des structures	*/
/* --------------------------------------------------------------------	*/
static int 
SauvegardeStructures(
       int	    Distingue	, 
       Int32*	    DebPart	, 
       Int32*	    FinPart	, 
       Int32	    Lmax	,  /* longueur max d'une sequence	*/
       Int32	    N		,  /* nombre de sequences		*/
       char*	    s		,  /* tableau des sequences		*/
       Int32	    NbPal[]	,  /* nombre pal de chaque sequence	*/
       Palindrome   *Pals[]     ,  /* pal de chaque sequence		*/
       WordBunchPtr AllStr	,  /* positions des structures		*/
       TPosition    Pos[]	,  /* vecteur des positions des struc	*/
				   /* dans les sequences et solutions	*/
       Int32***	    Sols        , 
       Int32***	    M[]		, 
       StructModel* SModel	, 
       Int32*       Best
   	           )       

{
  
  TInstance* Instances = NULL      ; /* Occurrences des structures	*/
  Int32 NbInstances    = 0	   ; /* Nb instances de structures	*/
  Int32 ClasseInstance = 0         ; 
  Int32 MaxInstances   = 0         ; 
  Int32 NbInstancesTot = 0         ;
  int   OrdreElts[MAX_LONGUEUR_STRUCTURES] ; 
				      /* ordre tetes et queue dans str */
  Int32  i			   ;
  Int32  k			   ;
  Int32  ea         = -1	   ;
  Int32  c			   ;
  StackiHdle Structures		   ;
  Int32  val			   ;
  Int32 Seq			   ;
  Int32 Sol			   ;
  Int32 Pal		           ;
  int   premier			   ; /* temoin 1er elet d'une classe	*/
  Int32 u			   ;
  int   affiche   = 0              ;
  int   ok_classe = 1              ;
  StructModel  Structure	   ;
  StructModel  Tampon		   ;
  int   iterer = 1	           ; /* temoin arret lecture classe	*/
  
 
  fprintf(stderr,"Sauvegarde des resultats en cours...\n") ;

  fprintf(stdout,"Nombre de sequences : %d\n\n",N)  ;

						    /* sauvegarde positions structures */			
  CursiToTop(AllStr->nbwords) ;
  CurspToTop(AllStr->words)   ;

						    /* sauve nombre de longueurs	*/
    
  for (k = AllStr->maxlen ; k >= AllStr->minlen ; k--) 
  {
						    /* sauve longueur k			*/

      fprintf(stdout,"\n\nlongueur           : %d \n",k) ;

						    /* sauve nombre classes longueur k	*/
     
      if (!ReadiDown(AllStr->nbwords,&ea))
      {
	  fprintf(stderr,"probleme lecture ea (%d)\n", ea) ;
          return 0 ;
      }

      fprintf(stdout,"nombre de classes  : %d\n\n",ea)     ;

						    /* ecrit les positions debut structure */
						    /* (pal + a droite) de chaque classe   */

      ReadpDown(AllStr->words,(Ptr *) &Structures) ;

						    /* curseur haut chaque pile		    */
     for (c = 0 ; c < ea ; c++)
          CursiToTop(Structures[c]) ;

						    /* pour chaque sequence		    */
     for (i = N-1 ; i >= 0 ; i--)
     {
	 fprintf(stderr,"sequence %d\n",i) ;

         NbInstancesTot = 0        ;
	 Instances      = NULL     ; 
         MaxInstances   = 0        ;

         for ( c = 0 ; c < ea ; c++)
	       MaxInstances += Structures[c]->top ;
	  
	 Instances =  malloc(MaxInstances * sizeof(TInstance))			 ;
         CheckNullPtr("Pas assez de memoire pour allouer Instances\n",Instances) ;

				    		/* pour chaque classe longueur k	    */
         for (c = 0 ; c < ea ; c++)  
         {
          affiche = 0 ;	
	  premier = 1 ;

          NbInstances    = 0 ;
          ClasseInstance = 0 ;
	  iterer         = 1 ;
	 
	  while (iterer && ReadiDown(Structures[c],&val)) 
	  {
		 
		  Seq  = Pos[val].Seq      ; 
		  Sol  = Pos[val].Sol      ;
		  Pal  = Pos[val].Pal      ;	
	  
	   				 			     		    		   		         	              	      					
		      if (premier)
		      {			   			          					        			    			                               			   
			  premier = 0         ;			 			  
			  Structure[0] = '\0' ;	
		  	  				/* recupere classe structure	*/
			  for (u = k - 1 ; u >= 0 ; u--)	
 			  {		 
                              Tampon[0] = '\0' ;

                              if (u == 0)
				  sprintf(Tampon, "%d", M[Seq][Sol][Pal][Pal-u])  ;
 			      else
				  sprintf(Tampon, "%d ",M[Seq][Sol][Pal][Pal-u])  ;	

			      strcat(Structure,Tampon) ;
			  }

			  ok_classe = DansSelection(Structure, SModel, Best) ;
			  
			  if (ok_classe && Seq == i)
                          {
			     affiche = 1							  ;
			     AfficheSequence (i,  NbPal, s, Lmax,  Distingue, DebPart[i], FinPart[i]) ;
			  	    
                             fprintf(stdout,"%s", Structure) ;
	
					/* affichage du tRNA				*/
                             fprintf(stdout,"         ") ;
		             /* Affiche_trna(DebPart[i], FinPart[i]) ; */
		             fprintf(stdout,"\n") ;
			     fprintf(stderr,"%s\n", Structure) ;	
		          } /* fin de ok_classe
			             
		       }  /* Fin de if premier		*/
		       
		       if (ok_classe && Seq == i)
		       {
		           ClasserElts(k, OrdreElts, M, Seq, Sol, Pal) ;
                           if (InsereInstance(ClasseInstance, k, Instances, Sol, Pal, 
		                              &NbInstances, Sols[i]))    
			        AfficherStructure(OrdreElts, Seq, Sol, Pal, Pals,  Sols, k) ;
		       }   /* fin de ok_classe && Seq == i */
		       else
		       {
			  iterer = 0 ;		       
			  	   	/* element lu appartient a sequence < i */		  			
		 	  	        /* repositionne pointeur sur element 	*/
			  (Structures[c]->cursor)++ ;
	               } 
			   		                       					         
		    		    
           }  /* fin de While continue ...*/
           
           if (affiche)
           {
               fprintf(stdout,"Instances = %d\n",NbInstances) ;
               NbInstancesTot += NbInstances ; 
           }
        }   /* fin de for c */
    
    free(Instances) ;
    fprintf(stdout,"Instances cumulees = %d\n",NbInstancesTot) ;
    }  								/* fin de for i */
  }								/* fin de for k */

 
  fprintf(stderr,"Fin sauvegarde des resultats.\n") ;
  return 1	  ;
} 
/* fin de SauvegardesStructures */
