/* ------------------------------------- */
/* Palamou10  :                          */
/* introduit la notion de score de 	 */ 
/* chaque palindrome			 */
/* soit modele simple GC = 3 AT = 2      */
/* soit modele de SALSER		 */
/* version trivial sur PC recherche      */
/* des palindromes avec			 */
/* tolerance sur les liaisons	 	 */
/* irregulieres			         */
/* integre possibilites debut et fin     */
/* avec liaisons irregulieres	         */
/* Version Novembre 1994		 */
/*					 */
/* Traitement des bases neutres N	 */
/* Tolere les gaps 			 */
/*					 */
/* options :			 	 */
/*					 */
/* -i         : accept (1) or not 0 default value) 		*/
/*		nonstandard pairing at the begining and  	*/
/* 		the end of the palindromes 			*/
/*              en tete et fin pal (0)    			*/
/*					 			*/
/* -z<entier> : length of the windows (200)               	*/
/*               			 */
/* -m<entier> : long min tige (4)	 */
/*                                       */
/* -b<entier> : long min de boucle (3)   */
/*					 */
/* ------------------------------------- */


#ifndef THINK_C
#include <sys/types.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#include "../../include/param.h"
#include "../../include/gtypes.h"
#include "../../include/libsys.h"


#ifdef THINK_C
extern int __ccommand(char ***argv);
#endif


/*----------------------------------------------*/
/* CONSTANTES					*/
/* -------------------------------------------- */


#define ALPHABET        "GATCN-"

#define CARD	5

#define OUTPUT_REQUIRED 1   

#define SORTIE stdout

#define ENTREE stdin

#define LMAX 400

#define MAXINT 15000

#define MAXPAL  5000



/*----------------------------------------------*/
/* MACROS					*/
/* -------------------------------------------- */


#define ARGUMENT(a,b,c) if (c[0] == '0') a = 0 ; else {a = atoi(c) ;if (!a) {fprintf(stderr,"Mauvais argument -%c %s\n",b,b); return 0 ;}}



/*----------------------------------------------*/
/* definitions des types			*/
/* -------------------------------------------- */

 typedef struct  
        {
         int Head        ;
         int LengthHead  ;
         int Tail        ;
         int LengthTail  ;
         int Code        ;
	 int Retenu      ;
	 int Score	 ;
        }  palindrome ;

/* -------------------------------------------- */
/* definitions des variables globales		*/
/* -------------------------------------------- */

static char  	 *DerRegulier1    = NULL ;
static char  	 *DerRegulier2    = NULL ;
static char      *FirstIrregulier = NULL ;
static palindrome Palinds[MAXPAL]        ;
static int        NbPals = 0             ;



/* -------------------------------------------- */
/* local prototypes				*/
/* -------------------------------------------- */
   
static void	Erreur (char *msg, int stat);
static char	*LireData (int *buflen);
static Bool	VerifySeq (char *seq, char *alpha);
static Bool	IsRegularComplement (char c, char cc) ;
static void     SelectPal (int ModeleSaler[][5], char *Seq    , Int32 Numero   , char *StartHead,
			    char *EndHead, char *StartTail, char *EndTail  ,
			    Int32 Longueur, Bool Code
			  ) ;
static void     PrintPal(int N) ;
static Bool	FatalComplement (int irregfirst,char *ss1, char *s2, Int32 *PoidsReguliers,
				Int32 *PoidsIrreguliers, Int32 MAppariements[CARD][CARD],
				Int32 Seuil,int *pCode);
static int      Inclut(int i,int k) ;
static void     Inclusions (void) ;
static int	indice (char c);
static int      AppariementSalser(int ModeleSalser[][5], char c1,char d1,
				  char c2, char d2) ;
static int      RangDansModele(char c1, char c2) ;

/* -------------------------------------------- */
/* erreur					*/
/* -------------------------------------------- */

static void Erreur(msg, stat)
	char *msg;
	int stat;
{
	fprintf(stderr, "Error: %s\n", msg);
	if (stat) exit(stat);
}

/* -------------------------------------------- */
/* lit une sequence de caracteres		*/
/* -------------------------------------------- */
static char * LireData(int *buflen)
{
	Int32	len, readlen;
	char 	*buffer, *buf ;
	char    nom[30] ;
	FILE    *fichier ;


	fprintf(stderr, "Reading data ... ");


	if (*buflen <= 0) 
           {
            fprintf(stderr,"Bad data length\n");
            return NULL ;
           }

	if ( !(buffer = NEWN(char, 2 * *buflen)))
           {
	    fprintf(stderr,"Not enough memory for data");
            return NULL ;
           }

	readlen = 0;
	/* lit le retour chariot */
	buf = buffer;
	fgets(buf,LMAX,stdin) ;

	while(fgets(buf,LMAX,stdin) != NULL) 
        {
	   if (buf[0]=='#') break;
	   len = strlen(buf) ;
	   if (buf[len-1] == '\n') 
           {
	       buf[len-1] = '\000';
	   }
	   len = strlen(buf) ;
	   buf += len;
	   readlen += len;
	}

	*buf = '\000';
	/* printf("buf %d read %d\n",(int)*buflen, (int)readlen); */
	if (readlen != *buflen)
           {
	    fprintf(stderr,"Incorrect data length");
            return NULL ;
           }

	fprintf(stderr, "done\n");
	return buffer;
}

/* -------------------------------------------- */
/* verifie les caracteres d'une sequence	*/
/* -------------------------------------------- */
static Bool VerifySeq(seq, alpha)
	char *seq, *alpha;
{
	fprintf(stderr, "Verifying sequence ... ");

	for ( ; *seq ; seq++)
	    if (! strchr(alpha, *seq)) 
            {
		fprintf(stderr, "Bad symbol in seq : %c\n", *seq);
		return Faux;
	    }

	fprintf(stderr, "done\n");

	return Vrai;
}



/* -------------------------------------------------*/
/* impression et mise a jour d'un palindrome	    */
/* s1 = start head; ss1 = end head; s2 = start tail */
/* a verifier sur l'entree palingol 		    */
/* ------------------------------------------------ */

static void SelectPal(ModeleSalser, Seq    , NbPals   , StartHead,
		     EndHead, StartTail, EndTail  ,
		     Longueur,Code
		    )
	int ModeleSalser[][5] ;
	char   *Seq, *StartHead, *EndHead, *StartTail, *EndTail ;
	Int32  NbPals, Longueur ;
        Bool Code ;


{
   Int32 Sh, Eh, St, Et ;
   int i		;
   int Score		;


   Sh = (Int32) (StartHead - Seq + 1) ;
   St = (Int32) (StartTail - Seq + 1) ;
   Palinds[NbPals].Head = Sh ;
   Palinds[NbPals].LengthHead = Longueur ;
   Palinds[NbPals].Tail = St ;
   Palinds[NbPals].LengthTail = Longueur ;
   Palinds[NbPals].Code = Code ;
   Palinds[NbPals].Retenu = 1 ;
   Score = 0 ;
   for (i = 0 ; i < Longueur-1 ; i++) 
   {
	   Score += AppariementSalser(ModeleSalser,
				     *(StartHead + i), *(StartHead + i + 1),
				     *(EndTail - i),  *(EndTail - i - 1)) ;
   }
   Palinds[NbPals].Score = Score ;
}

static void PrintPal(int N)
/* ecrit un palindrome */
{

   fprintf(stdout,"%d %d ",Palinds[N].Head,
	  Palinds[N].Head + Palinds[N].LengthHead -1) ;
   fprintf(stdout,"%d %d ",Palinds[N].Tail,
	  Palinds[N].Tail + Palinds[N].LengthTail-1) ;
   fprintf(stdout,"%d %d",Palinds[N].Code,Palinds[N].Score) ;
   fprintf(stdout,"\n") ;

}



/* -------------------------------------------- */
/* Recherche d'un indice dans la matrice des    */
/* appariements	                                */
/* -------------------------------------------- */
static int indice(char c)
{
    switch ((char)c) 
    {
	case 'G' : return (0) ;
	case 'A' : return (1) ;
	case 'T' : return (2) ;
	case 'C' : return (3) ;
	case 'N' : return (4) ;
    }
}
/* fin de indice */


/* ----------------------------------------------- */
/* Verifie que la liaison est regulierre	   */
/* ----------------------------------------------- */
static Bool IsRegularComplement(char c1, char c2)

{
	int i,j;

	i = indice(c1)  ;
	j = indice(c2)  ;
	if ((i+j == 3) || (i == 4) || (j == 4)) 
	    return Vrai;
	else
	    return Faux;
}


/* -------------------------------------------- */
/* relation d'appariement entre symboles	*/
/* tolere des appariements irreguliers	        */
/* -------------------------------------------- */
static Bool FatalComplement(int   irregfirst,
			    char  *ss1,
			    char  *s2,
			    Int32 *PoidsReguliers,
			    Int32 *PoidsIrreguliers,
			    Int32 MAppariements[CARD][CARD],
			    Int32 Seuil,
			    int   *pCode
			   )

{
	int    i                     , j              ;
	Int32 Poids 				      ;
	int   Regulier 				      ;
				/* recherche les indices dans la matrice */
				/* des appariements			 */

	i     = indice(*ss1)             ;
	j     = indice(*s2)              ;
	Poids = MAppariements[i][j] ;

	Regulier = IsRegularComplement(*ss1, *s2) ;

	if (!Regulier)
        { 		        /* appariement irregulier  		 */
				/* on incremente le nombre d'irreguliers */
				/* d'un poids contenu dans la matrice    */
				/* des appariements	                 */
		*PoidsIrreguliers += Poids ;
		if (Poids >= Seuil)
				/* appariement fatal    		 */
		   return Vrai ;
		else
		   if (*pCode == 1) 
                   {
		       *pCode = 0 ;
		       FirstIrregulier = ss1 ;
		   }
	}
	else  			/* appariement regulier                  */
	   *PoidsReguliers += Poids ;
	if (Regulier || (irregfirst ==1))
	   if (*PoidsReguliers >= *PoidsIrreguliers)
           {
	       DerRegulier1 = ss1 ;
	       DerRegulier2 = s2  ;
	   }
	return Faux ;


}
/* fin de FatalComplement */


/* ----------------------------------------------- */
/* teste l'inclusion de 2 palindromes   	   */
/* ----------------------------------------------- */
static int Inclut(int i,int k)
{
    int StartHead1 = Palinds[i].Head ;
    int EndHead1 = Palinds[i].Head + Palinds[i].LengthHead - 1 ;
    int StartTail1 = Palinds[i].Tail;
    int EndTail1 = Palinds[i].Tail + Palinds[i].LengthTail - 1 ;
    int StartHead2 = Palinds[k].Head ;
    int EndHead2 = Palinds[k].Head + Palinds[k].LengthHead - 1 ;
    int StartTail2 = Palinds[k].Tail;
    int EndTail2 = Palinds[k].Tail + Palinds[k].LengthTail - 1 ;

    return (
  	     /* Tete et Queue du pal2 commence a meme distance par	*/
	     /* rapport a fin Tete et debut Queue de pal 1		*/
       	     EndHead1-EndHead2 == StartTail2 - StartTail1  &&
             EndHead2 <= EndHead1 &&
             EndTail2 <= EndTail1 &&
             StartHead2 >= StartHead1 &&
             StartTail2 >= StartTail1
           ) ;
}



/* ----------------------------------------------- */
/* Recherche des inclusions dans les palindromes   */
/* ----------------------------------------------- */
static void Inclusions(void)
{
  int i = 1 ;
  int k     ;
  int elimine ;

  /* le palindrome i est le pivot provisoire				*/
  while (i < NbPals) 
  {
        k= i+1 ;
	while (k <= NbPals &&
	       Palinds[k].Head < Palinds[i].Head + Palinds[i].LengthHead) 
        {
	       /* on ne compare pas avec les palindromes de StartHead	*/
               /* identique : dans Palamou pas d'inclusion possible	*/
               if (Palinds[k].Head != Palinds[i].Head &&
		   Palinds[k].Retenu == 1 &&
		   Inclut(i,k)
		  )
		   Palinds[k].Retenu = 0 ;
	       k++ ;
        }
        i++ ;
  }

}


/* calcule la contribution energetique de l'appariement courant */
/* selon le modele de SALSER					*/
int   AppariementSalser(int ModeleSalser[][5],
			char c1, char d1, char c2, char d2)
{
   int i ;
   int j  ;


   DetermineBases(&c1,&c2) ;
   DetermineBases(&d1,&d2) ;

   i = RangDansModele(c1,c2) ;
   if (i == 5)
	return 0 ;
   else 
   {
	j = RangDansModele(d1,d2) ;
	if (j == 5)
	   return 0 ;
	else 
	   return ModeleSalser[i][j] ;
	
   }
}



ChangeBases(char* a, char* b)
{ 
 switch(*a) 
	    {
		case 'A' : *b = 'T' ; break     ;
		case 'C' : *b = 'G' ; break     ;
		case 'G' : *b = 'C' ; break     ;
		case 'T' : *b = 'A' ; break     ;		
	    }		
}


/* ----------------------------------------------- */
/* determine les bases neutres (N) en fonction	   */
/* de la situation la plus favorable		   */
/* ----------------------------------------------- */
DetermineBases(char* c1, char* c2)
{
	if (*c1 == 'N')
        {
	  ChangeBases(c2,c1) ;
          if (*c2 == 'N')
          {
  	     *c1 = 'G' ; *c2 = 'C' ; 			/* configuration favorable	*/
	  }						/* du point de vue energie	*/	   
        }
	else if (*c2 == 'N')
        {
	    ChangeBases(c1, c2) ;
        }
}



int RangDansModele(char c1, char c2)
{
   if (c1 == 'C' && c2 == 'G')
      return 0 ;
   else if (c1 == 'G' && c2 == 'C')
      return 1 ;
   else if (c1 == 'T' && c2 == 'A')
      return 2 ;
   else if (c1 == 'A' && c2 == 'T')
      return 3 ;
   else if (c1 == 'G' && c2 == 'T')
      return 4 ;
   else     
      return 5 ;  
}




/* ---------------------------------------- */


main(argc, argv)
	int  argc ;


	char *argv[];

{
	/* Matrice des appariements :				      */
	/* reguliers sur la diagonale, irreguliers en dehors	      */
	/* chaque valeur represente un poids pour l'appariement       */
	/* matrice carre :  GATCN (lignes) x GATCN (colonnes)         */

	Int32  MAppariements [CARD][CARD] = 
  	       {
	       		{ MAXINT , MAXINT , 3      , 1	   , 1 } ,
	       		{ MAXINT , MAXINT , 1      , MAXINT, 1 } ,
	       		{ 3      , 1      , MAXINT , MAXINT, 1 } ,
	       		{ 1      , MAXINT , MAXINT , MAXINT, 1 } ,
			{ 1	 , 1	  , 1      , 1     , 1 }
	
		} ;


	/* energie des appariements selon le modele de Salser		*/

	int ModeleSalser [5][5] = 
	    {
		 {480, 300, 210, 210, 130},
		 {430, 480, 210, 210, 130},
		 {210, 210, 120, 180,  30},
		 {210, 210, 180, 120,  30},
		 {130, 130,  30,  30,  30}
	    } ;

	Int32 		 seqlen, wlen,       nbfound            ;
	Int32		 PoidsReguliers , PoidsIrreguliers      ;
	Int32            Delta,buflen                           ;
	char 		 *seq, *finseq, *s1, *s2, *ss1, *debs2 	;
	char 		 alphabet[CARD+2]             		;
	int              code, i,Total,NbSeq	                ;
        int              irregfirst = 0                         ;
	int   		 Score					;
        int              minlen = 4			        ;
        int              bmin = 3				; 
        int              zone   = 200                           ;
        char             Symb                                   ; 
                         /* symbole argument de main */
        char      Argument[50]	                                ; 
                         /* argument de main	     */

        Int32   NbPalMoy = 0                                    ;
        int     OnSort   = 0                                    ;
	char    c1						;
	char    c2						;
        int     Distingue =  0					;
        int     DebPart	  = -1					;
	int     FinPart	  = -1					;


fprintf(stderr,"Palamou10\n") ;

   
    while (SelectArg("-i -m -z -b -k",&Symb,Argument,argc,argv)) 
    {
	  switch (Symb) 
          {
		 case 'm' : ARGUMENT(minlen,Symb,Argument)      ;
			    break	                        ;

		 case 'z' : ARGUMENT(zone,Symb,Argument)        ;
			    break	                        ;

                 case 'b' : ARGUMENT(bmin,Symb,Argument)        ;
			    break	                        ;

		 case 'i' : irregfirst = 1             		;
			    break 				;

	 }
    }


   fprintf(stderr,"Irregulier   = %d\n",irregfirst) ;
   fprintf(stderr,"Longueur min = %d\n",minlen)     ;
   fprintf(stderr,"Zone         = %d\n",zone)       ;
   fprintf(stderr,"Boucle min   = %d\n",bmin)       ;

   strcpy(alphabet, ALPHABET)   ;
   NbSeq = 0 ;
  
   fprintf(stderr,"Lecture des donnees en cours...\n") ;

   while (!OnSort && fscanf(stdin,"%ld",&buflen) && buflen != 0)  
   {

	 if (Distingue)
             fscanf(stdin,"%d %d", &DebPart, &FinPart) ;	

				/* lecture des donnees	*/

        fprintf(stderr,"Sequence %d\n",NbSeq) ;
	seq = NULL ;

	if ((seq = LireData(&buflen)) && VerifySeq(seq, alphabet)) 
        {

        	NbSeq++ ;

		fprintf(stderr,"%s\n\r",seq) ;

		seqlen = strlen(seq);

				/* algorithme trivial	*/
				/* version molle	*/
	        NbPals  = 0   ;

		finseq = seq + seqlen - 1;

		for (s1 = seq ; *s1 ; s1++) 
		{  			/* foreach position               */

                 if (*s1 != '-')
                 {
		    	s2 = s1 + zone - 1;
		    	if (s2 > finseq)
	        		s2 = finseq;

					/* recherche debut palindrome	  */

	    		while (s2 > s1) 
			{

			 
		            if (irregfirst == 1 ) /* debut et fin irregulier tolere 	     */
		    			       /* recherche du premier appariement non fatal */
		               while (
 				      (s2 > s1) && 				
			               ( 
					 (*s2 == '-') ||
					(MAppariements[indice(*s1)][indice(*s2)] == MAXINT)				        
                                       ) 			       
			             )
			             s2 -- ;
		            else
		 			 /* recherche du premier appariement regulier		 */
		  			 /* entre s1 et s2   					 */
		            while (
				    (s2 > s1)	&&
			            (
				      (*s2 == '-') ||
 			              (! IsRegularComplement(*s1,*s2 ))			         
                                    )
			          )
			             s2-- ;
                       

		           if   (s2 > s1) 
 		               { 					/* s1 et s2  debut du pal      	 */
			    if (IsRegularComplement(*s1,*s2 )) 
			    {
			       					/* debut regulier 		 */
			       PoidsReguliers = MAppariements[indice(*s1)]
							     [indice(*s2)] ;
			       PoidsIrreguliers = 0 ;
			       code = 1 ;
			       FirstIrregulier = NULL ;
			    }
			    else 
			    { 					/* debut irregulier		 */
			       PoidsReguliers = 0 ;
			       PoidsIrreguliers =  MAppariements[indice(*s1)] [indice(*s2)] ;
			       code = 0 ;
			       FirstIrregulier = s1 ;
			    }

			    wlen             =        1 ;
						  			/* fin pal cote gauche */
			    DerRegulier1     =       s1 ;
						 			 /* fin pal cote droit  */
			    DerRegulier2     =       s2 ;
			    debs2            =       s2 ;
			    ss1              =   s1 + 1 ;
			    s2 --                       ;
			    while ((s2 > ss1) &&
				   (!FatalComplement(irregfirst,
						     ss1,
			   			     s2 ,
						     &PoidsReguliers,
						     &PoidsIrreguliers ,
						     MAppariements  ,
						     MAXINT,
						     &code
						    )
				   )
				  ) 
 			    {
				  s2--             ;
				  ss1++            ;
			    }
			  			 	 /* [s1,DerRegulier1] et [DerRegulier2,debs2]    */
			  				 /* representent le pal cote Head et Tail        */
			   if ((FirstIrregulier != NULL) &&
			       (FirstIrregulier > DerRegulier1))
			       					 /* la premiere liaison irreguliere est */
			      					 /* hors palindrome		        */
			       code = 1 ;
		  	   wlen = DerRegulier1 - s1 + 1 ;
			   if (wlen >= minlen && 
                               (DerRegulier2-DerRegulier1) > bmin)
			       SelectPal(ModeleSalser,seq,++NbPals   ,
					 s1, DerRegulier1,
					 DerRegulier2, debs2,
					 wlen,code
					) ;
			   					/* s2 point sur elt suivant debut pal 	*/
			   s2 = debs2 - 1 ;
		      }
		      /* fin du if s2 > s1 */

	    }
	    /* fin du while (s2 > s1) */

         } /*  fin du if (*s1 != '-') */

	}
	/* fin du for */


         /* traite les inclusions					*/
   
	Inclusions() ;

	 if (Distingue)
           fprintf(stdout,"%d %d\n", DebPart, FinPart) ;
        fprintf(stdout,"%s\n",seq) ;

	Total = 0 ;
	for (i=1;i<=NbPals;i++)
	    if (Palinds[i].Retenu == 1) 
            {
	       Total ++ ;
	       PrintPal(i) ;
	    }

	fprintf(stderr,"%d palindrome(s) trouve(s)\n",NbPals) ;
	fprintf(stderr,"%d palindrome(s) conserve(s)\n",Total) ;
	fprintf(stderr,"%d palindrome(s) inclu(s) \n",(NbPals - Total)) ; 
	fprintf(stdout,"#\n") ;

        NbPalMoy += Total ;
        }   /* fin du if */
        else
            OnSort = 1 ;

	FREE(seq);


    }   /* fin du While !feof() */

    fprintf(stderr,"\nNombre de sequences traitees %d\n",NbSeq) ;
    fprintf(stderr,"Nombre moyen de palindromes %.2f\n",(1.0*NbPalMoy/NbSeq)) ;
    fprintf(stderr,"fin du programme \n") ;

}
/* fin de la fonction  main */  
