/* ------------------------------------- */
/* engendre une zone aleatoire en 5' et  */
/* 3' d'une sequence d'ARN		 */
/* ------------------------------------- */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <libgen.h>

#include "../Param/param.h"
#include "../../Include/gtypes.h"
#include "../Include/libsys.h"

#define MAX_RND 0x7fffffff      /* plus grand entier aleatoire		*/
#define NB_BASES 50	   	/* nb base sur une ligne		*/
#define LONG 500		/* longueur max d'une sequence		*/
#define LINE_FEED 10		/* retour chariot			*/
#define ALPHABET "ACGTN"	
#define TAILLE_ALPHABET 4       /* sequence d'ARN (ADN)			*/



static void ARGUMENT(int* a, char b, char c[])
{
     if (c[0] != '0') 
     {
          *a = atoi(c) ;
          if (!a) 
          {
		fprintf(stderr,"Mauvais argument -%c %s\n",b,c); 
                exit(0) ;
	  }
     }
}		 


static 	void PartieAleatoire(
			     int Taille	/* longueur parie aleatoire	*/
		            )
{
   int   j	 ; 			/* indice nucleotides		*/ 
   int   NbBases ;			/* nb bases ecrites		*/
   int   c       ;			/* nucleotide			*/
 
   int  x       ;			/* nombre aleatoire		*/
   

   for (j = 1 ; j <= Taille ; j++)
   {	
					/* tirage au sort de la base  	*/	
	x = (int) ((random() / (1.0 * MAX_RND)) * TAILLE_ALPHABET) ;

	if      (x < 1)
             c = 'A' ;
        else if (x < 2)
             c = 'C' ;
        else if (x < 3)
             c = 'G' ;
        else 
             c = 'T' ;        

        fprintf(stdout,"%c", c) ;

        if ((j % NB_BASES) == 0) 
	     fprintf(stdout,"\n") ;
    }  

    if ((Taille % NB_BASES) != 0) 
	     fprintf(stdout,"\n") ;	        	
}	
			
			


void main(int argc, char * argv[])  
{
 int 	LongSeq 	; /* longueur des sequences			*/
 char   Sequence1[LONG]	; /* sequence permuttee				*/
 int    j		; /* indice de base				*/
 char 	c		; /* base					*/	 
 char   Symb            ; /* symbole argument de main 			*/
 char   Argument[50]    ; /* argument de main	     			*/
 int    N = 0		; /* nb de sequences				*/
 int    Longueur        ;
 int    repetition = 1	; /* nb sequences shufflees par sequence bio	*/
 int    r		; /* indice de repetition d'une meme sequence	*/
 int    NSorties = 0    ; /* nb sequences en sortie			*/
 int    variables	; /* nb nucleotides variables			*/
 int    partie_variable	; /* 1 si dans partie degeneree de l'ARN	*/
 int    part1  	= -1	; /* debut partie variable			*/
 int 	part2 	= -1 	; /* fin partie variable			*/
 int    Taille  = 25     ;
 char   Separateur[LONG] ;

 

  fprintf(stderr,"programme %s 1 \n", argv[0]) ;
 /* pathfind(getenv ("PATH"), argv[0], "rx")) ; */
  fprintf(stderr,"%s\n", heure()) ;
   
  srandom((int)time(NULL)) ;

  						/* Initialisation	*/
  Separateur[0] = 0 ;

    
  while (SelectArg("-n -t",&Symb,Argument,argc,argv)) 
  {
	  switch (Symb) 
          {
		 case 'n' : ARGUMENT(&repetition,Symb,Argument)      ;
			    break	                             ;	 

	         case 't' : ARGUMENT(&Taille,Symb,Argument)          ;
			    break				     ;
	  }
  }

 fprintf(stderr,"nombre de repetitions %d\n",repetition) ; 

 while (!feof(stdin))
  {
						/* lecture de la sequence courante	*/
	LongSeq   = 0 ;
	Longueur  = 0 ;
      
	fscanf(stdin,"%d",&LongSeq) ;
		   	
	while (Longueur < LongSeq)
	{
	 	fscanf(stdin,"%c",&c)            ;
	        						
		if (strchr(ALPHABET,c) ) 
		{	  
		   Sequence1[Longueur] = c       ; 
		   Longueur++ 			 ; 
		}     	 								
	}

	fscanf(stdin,"%s",Separateur)	;	/* lecture du #				*/
		
	if (Longueur > 0)
	{
	    N++ ;
	    fprintf(stderr,"%d %d\n", N, Longueur) ;
            fprintf(stdout,"%d\n",Longueur + 2 * Taille) ;
	    fprintf(stdout,"%d %d\n", Taille + 1, Longueur + Taille)                 ;
            
	    for (r = 1 ; r <= repetition ; r++)
	    {	   			
				/* ecrit la nouvelle sequence	*/
		
					/* Partie 5' aleatoire		*/

		PartieAleatoire(Taille) ;

					/* Partie centrale fixe		*/
				
		for (j = 1  ; j <= Longueur ; j++)
		{
			fprintf(stdout,"%c",Sequence1[j-1])            ;
			if ((j % NB_BASES) == 0) 
	           		fprintf(stdout,"\n") ;
		}		

		if ((Longueur % NB_BASES) != 0) 
	        	fprintf(stdout,"\n") ;	
	
					/* Partie 3' aleatoire		*/

		PartieAleatoire(Taille) ;	               		

		fprintf(stdout,"#\n") ;

	        NSorties++ ;
	    }
	}
 }

  fprintf(stderr,"nombre de sequences traitees  : %d\n",N) ;
  fprintf(stderr,"nombre de sequences en sortie : %d\n", NSorties) ;
  fprintf(stderr,"fin du programme\n") ;	
}

