/* ------------------------------------- */
/* engendre aleatoirement une zone d'ARN */
/* tout en conservant une zone fixe 	 */
/* de part et d'autre			 */
/* -n<entier> :  nombre de sequences	 */
/*               aleatoires / seq bio	 */
/* ------------------------------------- */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>

#include "../Param/param.h"
#include "../../../Include/gtypes.h"
#include "../Include/libsys.h"

#define MAX_RND 0x7fffffff      /* plus grand entier aleatoire		*/
#define NB_BASES 50	   	/* nb base sur une ligne		*/
#define LONG 500		/* longueur max d'une sequence		*/
#define LINE_FEED 10		/* retour chariot			*/
#define ALPHABET "ACGTN"	
#define TAILLE_ALPHABET 4       /* sequence d'ARN (ADN)			*/


void ARGUMENT(int* a, char b, char c[])
{
     if (c[0] != '0') 
     {
          *a = atoi(c) ;
          if (!a) 
          {
		fprintf(stderr,"Mauvais argument -%c %s\n",b,b); 
                exit(0) ;
	  }
     }
}		 



void Engendre(int part1, int part2, char Sequence1[], int LongSeq) 
{
   int i             ;   		/* position base dans sequence	*/
   int c             ; 	  		/* base				*/   
   long   x          ; 
    
   Sequence1[LongSeq] = 0 ;
 
   for (i = part1 ; i <= part2 ; i++)
   {	
					/* tirage au sort de la base  	*/	
	x = random() ;
	c = (int) ((x / (1.0 * MAX_RND)) * TAILLE_ALPHABET) ;

	if      (c < 1)
             Sequence1[i] = 'A' ;
        else if (c < 2)
             Sequence1[i] = 'C' ;
        else if (c < 3)
             Sequence1[i] = 'G' ;
        else 
             Sequence1[i] = 'T' ;        
    }          
}



/* bascule booleenne	*/
void inverse(int* i) 
{
     if (*i) 
	*i = 0 ;
     else
	*i = 1 ;
    
}


main(int argc, char * argv[])  
{
 int 	LongSeq 	; /* longueur des sequences			*/
 char   Seq[LONG]	; /* sequence originale				*/
 char   Sequence1[LONG]	; /* sequence permuttee				*/
 int    i		; /* indice de sequence				*/
 int    j		; /* indice de base				*/
 char 	c		; /* base					*/	 
 char   Symb            ; /* symbole argument de main 			*/
 char   Argument[50]    ; /* argument de main	     			*/
 int    nA		; /* nb bases A dans une sequence		*/
 int    nT		; 
 int    nG		;
 int    nC		;
 int    N = 0		; /* nb de sequences				*/
 int    Longueur        ;
 int    repetition = 1	; /* nb sequences shufflees par sequence bio	*/
 int    r		; /* indice de repetition d'une meme sequence	*/
 int    NSorties = 0    ; /* nb sequences en sortie			*/
 int    variables	; /* nb nucleotides variables			*/
 int    partie_variable	; /* 1 si dans partie degeneree de l'ARN	*/
 char*  base		; /* caractere lu est une base			*/
 int    part1  	= -1	; /* debut partie variable			*/
 int 	part2 	= -1 	; /* fin partie variable			*/

 

fprintf(stderr,"debut du programme aleaz\n")   ;
   
 srandom((int)time(NULL)) ;

    
  while (SelectArg("-n",&Symb,Argument,argc,argv)) 
  {

	  switch (Symb) 
          {
		 case 'n' : ARGUMENT(&repetition,Symb,Argument)      ;
			    break	                             ;	 
	  }
  }

 fprintf(stderr,"nombre de repetitions %d\n",repetition) ; 

 while (!feof(stdin))
  {
						/* lecture de la sequence courante	*/
	LongSeq   = 0 ;
	Longueur  = 0 ;
        variables = 0 ;

	fscanf(stdin,"%d",&LongSeq) ;
		   
	partie_variable = 0 ;

	while (Longueur < LongSeq - 2)
	{
	 	fscanf(stdin,"%c",&c)  ;
	        
		if (c == '?')
		{
		   inverse(&partie_variable) ;
		   fscanf(stdin,"%c",&c)    ;

		   if (partie_variable)
		       part1 =  Longueur ;
		   else
		       part2 =  Longueur-1 ;
		}

		if (partie_variable) 			 	   		
			variables++ ;		
		
		base = strchr(ALPHABET,c) ;

		if (base) 
		{
		  if (!partie_variable)
			 Sequence1[Longueur] = c ; 
		    Longueur++ 			 ; 
		}     	 								
	}

	fscanf(stdin,"%s",Seq)	;		/* lecture du #				*/
		
	if (Longueur > 0)
	{
	    N++ ;
	    fprintf(stderr,"%d %d %d\n", N, Longueur, variables) ;
            
	    for (r = 1 ; r <= repetition ; r++)
	    {
	   	Engendre(part1, part2, Sequence1, Longueur) ;

				/* ecrit la nouvelle sequence	*/

		fprintf(stdout,"%d\n",Longueur)                        ;    
		fprintf(stdout,"%d %d\n",part1+1, part2+1)             ;		

		for (j = 1  ; j <= Longueur ; j++)
		{
			fprintf(stdout,"%c",Sequence1[j-1])            ;
			if ((j % NB_BASES) == 0) 
	           		fprintf(stdout,"\n") ;
		}
	
		if ((Longueur % NB_BASES) != 0) 
	        	fprintf(stdout,"\n") ;		               

		fprintf(stdout,"#\n") ;

	        NSorties++ ;
	    }
	}
 }

  fprintf(stderr,"nombre de sequences traitees  : %d\n",N) ;
  fprintf(stderr,"nombre de sequences en sortie : %d\n", NSorties) ;
  fprintf(stderr,"fin du programme\n") ;	
}

