#include <stdio.h>
#include <unistd.h>
#include <string.h>

#define ALPHABET	"GATC"
#define T_ALPH		4

static char buffer[BUFSIZ];
static int  freq[T_ALPH][T_ALPH];

static char *alphabet = ALPHABET;

/* -------- */
static void error(msg, stat)
	char *msg;
	int stat;
{
	fprintf(stderr,"error : %s\n", msg);
	if (stat)
	    exit(stat);
}

/* -------- */
static FILE *verify (nom)
	char *nom;

{
	FILE *file;

	fprintf (stderr,"verifying file %s",nom);
		
	if ( !(file = fopen (nom,"r") ) )
		error("cannot open file", 2);

	return file;
}

/* */
static void compte (fich)
	FILE *fich;

{
	char c2,c1;
	int r1,r2;

	c1 =  getc ( fich ) ;

	while ( ( c2 = getc ( fich ) ) != EOF ) {

		if ( c2 == '\n' ) continue;

		r1 = rang(c1) ;
		r2 = rang(c2) ;
		++freq[r1][r2] ;

		c1 = c2 ;

	}

}

/* ---------------------------------------------- */
/* calcule le rang d'un caractere dans l'alphabet */
/* ---------------------------------------------- */

static int rang (c)
	int	c;
{
	int	rng;
	char	*ptr;

	if (ptr=strchr(alphabet,c))
		rng=(int)(ptr-alphabet);
	else
		rng = -1;

	return rng;

}


/* -------- */
main(argn, argv)
	int argn;
	char *argv[];
{
	int i,j,end;
	FILE *file;

	if (argn != 2)
	   error("usage : dinuc file", 1);

	if ( file = verify (argv[1]) )
	   fprintf (stderr," > OK\n");

	compte (file);

	for ( i = 0 ; i < T_ALPH ; i++ ) {
		for ( j = 0 ; j < T_ALPH ; j++ )
			fprintf (stdout,"%d ", freq[i][j] );
		printf ("\n",0);
	}

	
	exit ( 0 ) ;
}

