/* ============================================================== */

/* salser.c							  */

/* constitue un fichier contenant les parametres thermodynamiques */

/* de SALSER concernant les boucles des structures secondaires	  */

/* Version Janvier 						  */

/* ============================================================== */



#include <stdio.h>

#include <math.h>



#define INFINI 9999



#define LONGUEUR 31



int HGC[LONGUEUR] ;

int HAU[LONGUEUR] ;



int IGG[LONGUEUR] ;

int IGA[LONGUEUR] ;

int IAA[LONGUEUR] ;



void demande(int i)

{

      fprintf(stderr,"\n\n Point %d\n",i) ;

      fprintf(stderr,"HGC ? \n") ;

      scanf("%d",HGC+i) ;



      fprintf(stderr,"HAU ? \n") ;

      scanf("%d",HAU+i) ;



      fprintf(stderr,"IGG ? \n") ;

      scanf("%d",IGG+i) ;



      fprintf(stderr,"IGA ? \n") ;

      scanf("%d",IGA+i) ;



      fprintf(stderr,"IAA ? \n") ;

      scanf("%d",IAA+i) ;

}





interpole(int i, int x1, int x2)

{

   float a            ;

   float dx = x2 - x1 ;



   fprintf(stderr,"\n\nInterpolation point %d\n",i) ;



   a = 1.0 * (HGC[x2] - HGC[x1]) / dx ;

   HGC[i] = floor(HGC[x1] + a * (i-x1) + 0.5)  ;



   a = 1.0 * (HAU[x2] - HAU[x1]) / dx ;

   HAU[i] = floor(HAU[x1] + a * (i-x1) + 0.5) ;



   a = 1.0 * (IGG[x2] - IGG[x1]) / dx ;

   IGG[i] = floor(IGG[x1] + a * (i-x1) + 0.5) ;



   a = 1.0 * (IGA[x2] - IGA[x1]) / dx ;

   IGA[i] = floor(IGA[x1] + a * (i-x1) + 0.5) ;



   a = 1.0 * (IAA[x2] - IAA[x1]) / dx ;

   IAA[i] = floor(IAA[x1] + a * (i-x1) + 0.5) ;



}



main()

{



  FILE *fichier ;

  int  i	;

  int  x        ;







  for (i = 2  ; i <= 10 ; i++)

      demande(i) ;





  for (i = 12 ; i <= 20 ; i+=2)

      demande(i) ;



  for (i = 25 ; i <= 30 ; i+=5)

      demande(i) ;



  for (i = 11 ; i < 20 ; i+=2)

      interpole(i,i-1,i+1) ;



  for (i = 21 ; i < 25 ; i++)

      interpole(i,20,25) ;



  for (i = 26 ; i < 30 ; i++)

      interpole(i,25,30) ;





  fichier = fopen("salser.mod","w") ;



  fprintf(fichier,"%d %d %d %d %d\n",

	  INFINI, INFINI, INFINI, INFINI, INFINI) ;

  fprintf(fichier,"%d %d %d %d %d\n",

	  INFINI, INFINI, INFINI, INFINI, INFINI) ;



  for (i = 2 ; i < LONGUEUR ; i++)

      fprintf(fichier,"%d %d %d %d %d\n",

	      HGC[i], HAU[i], IGG[i], IGA[i], IAA[i]) ;



  fclose(fichier) ;



}

