#include <stdio.h>
#include <unistd.h>
#include <string.h>

#define ALPHABET	"GATC"
#define T_ALPH		4

static char buffer[BUFSIZ];
static int  freq[T_ALPH];

static char *alphabet = ALPHABET;

/* -------- */
static void error(msg, stat)
	char *msg;
	int stat;
{
	fprintf(stderr,"error : %s\n", msg);
	if (stat)
	    exit(stat);
}

/* -------- */
static FILE *verify (nom)
	char *nom;

{
	FILE *file;

	fprintf (stderr,"verifying file %s",nom);
		
	if ( !(file = fopen (nom,"r") ) )
		error("cannot open file", 2);

	return file;
}

/* */
static int cumul (fich)
	FILE *fich;

{
	int fr,n2,somme,longueur;

	longueur = 0 ;

		somme = 0 ;

		for ( n2 = 0 ; n2 < T_ALPH ; n2 ++ ) {

			fscanf (fich, "%d",&fr) ;
			somme = somme + fr;
			freq[n2] = somme;
fprintf(stderr,"%d ",somme);
		}

		longueur = somme;
fprintf(stderr,"\n");

	return longueur;

}

static void genere (len)
	int	len;
{

	int  n, n2, al_nuc, ncar;

	ncar = 0;

	srandom(2 * (long) time(NULL) + 1);

	for ( n = 0 ; n < len ; n++ ) {

		al_nuc = random() % freq[T_ALPH-1];

		n2 = 0 ;

		while (al_nuc > freq[n2])
			n2++;

		putchar(alphabet[n2]);

		if (ncar++ == 59) {
			putchar('\n');
			ncar=0;
		}

	}

	putchar('\n');

}

/* ---------------------------------------------- */
/* calcule le rang d'un caractere dans l'alphabet */
/* ---------------------------------------------- */

static int rang (c)
	int	c;
{
	int	rng;
	char	*ptr;

	if (ptr=strchr(alphabet,c))
		rng=(int)(ptr-alphabet);
	else
		rng = -1;

	return rng;

}


/* -------- */
main(argn, argv)
	int argn;
	char *argv[];
{
	int i,j,end,taille;
	FILE *file;
	char *sequence;

	if (argn != 2)
	   error("usage : seq2 freq_file", 1);

	if ( file = verify (argv[1]) )
	   fprintf (stderr," > OK\n");

	taille = cumul (file);

	genere (taille);

	exit ( 0 ) ;
}

