/* --------------------------------------------	*/
/* effectue les permuations des bases	 	*/
/* de sequences d'ARN			 	*/
/* -r<entier> :  # de repretiions /sequences	*/
/* -k         :  zone ARN		 	*/
/* --------------------------------------------	*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>

#include "../../include/param.h"
#include "../../include/gtypes.h"
#include "../../include/libsys.h"

#define MAX_RND 0x7fffffff      /* plus grand entier aleatoire		*/
#define NB_BASES 50	   	/* nb base sur une ligne		*/
#define LONG 500		/* longueur max d'une sequence		*/
#define LINE_FEED 10


static void 
ARGUMENT(
	 int* 	a, 
	 char 	b, 
	 char c[]
        )
{
     if (c[0] != '0') 
     {
          *a = atoi(c) ;
          if (!a) 
          {
		fprintf(stderr,"Mauvais argument -%c %s\n",b,c); 
                exit(0) ;
	  }
     }
}		 



static 
void Permutte(
		char 	Sequence1[]	, 
		int 	LongSeq		,
		int 	nA		, 
		int 	nT		, 
		int 	nG		, 
		int 	nC
	      ) 
{
   int i             ;   		/* position base dans sequence	*/
   int c             ; 	  		/* base				*/
   int lA            ;
   int lT            ;
   int lG 	     ;
   int lC 	     ;
   long   x          ; 
    
   Sequence1[LongSeq] = '\0' ;
 
   for (i = 0 ; i < LongSeq ; i++)
   {
	lA = nA       ;			/* limite des A dans espace de	*/
					/* proba [1,lC]			*/
   	lT = lA + nT  ;
   	lG = lT + nG  ;
   	lC = lG + nC  ;
					/* tirage au sort de la base  	*/	
	x = random() ;
	c = (int) (1 + 1.0 * (x - 0) * (lC-1) / (MAX_RND-0)) ;

        if 	(c <= lA)
	{
		Sequence1[i] = 'A' ;
		nA--  ;
	}	
 	else if (c <= lT)
	{
		Sequence1[i] = 'T' ;
		nT -- ;
	}	
	else if (c <= lG)
	{
		Sequence1[i] = 'G' ;
		nG--  ;
	}	
	else
	{
		Sequence1[i] = 'C' ;
		nC-- ;
	}	     
   }
}


main(int argc, char * argv[])  
{
 int 	LongSeq 	; /* longueur des sequences			*/
 char   Seq[LONG]	; /* sequence originale				*/
 char   Sequence1[LONG]	; /* sequence permuttee				*/
 int    i		; /* indice de sequence				*/
 int    j		; /* indice de base				*/
 char 	c		; /* base					*/	 
 char   Symb            ; /* symbole argument de main 			*/
 char   Argument[50]    ; /* argument de main	     			*/
 int    nA		; /* nb bases A dans une sequence		*/
 int    nT		; 
 int    nG		;
 int    nC		;
 int    N = 0		; /* nb de sequences				*/
 int    Longueur        ;
 int    repetition =  1	; /* nb sequences shufflees par sequence bio	*/
 int    r               ; /* indice de repetition d'une meme sequence	*/
 int    NSorties   =  0 ; /* nb sequences en sortie			*/
 int    Distingue  =  0 ; /* 0 si ARN non localise, ou toute la seq.	*/
 int	DebPart	   = -1 ; /* Debut ARN					*/
 int	FinPart	   = -1 ; /* Fin ARN					*/
 
  
  fprintf(stderr,"debut du programme (1) \n")   ;
   
  srandom((int)time(NULL)) ;

    
  while (SelectArg("-r -k",&Symb,Argument,argc,argv)) 
  {

	  switch (Symb) 
          {
		 case 'r' : ARGUMENT(&repetition,Symb,Argument)      ;
			    break	                             ;
		 case 'k' : Distingue = 1			     ;
			    break	                             ;				 
	  }
  }

 fprintf(stderr,"nombre de repetitions %d\n",repetition) ; 

 while (!feof(stdin) && fscanf(stdin,"%d",&LongSeq))
  {						/* lecture de la sequence courante	*/				        

        fprintf(stderr,"%d\n",LongSeq) ;

	if (!feof(stdin))
        {
           if (Distingue)
           {
              fscanf(stdin  ,"%d %d"  , &DebPart, &FinPart) 	;
              fprintf(stderr,"%d %d\n", DebPart, FinPart)	;
           }

	    Longueur = 0 ;		
	    nA 	     = 0 ; 
	    nT       = 0 ; 
	    nG       = 0 ; 
	    nC       = 0 ;

	    while (!feof(stdin) && Longueur < LongSeq && fscanf(stdin,"%c", &c))
	    {
	 	
		if (c != LINE_FEED)
 		{
			switch (c) 
         		{
		 		case 'A' :  nA++  ;
			    		    break ;
				case 'T' :  nT++  ;     	  	
					    break ;
		 		case 'G' :  nG++  ;	      	  	 
					    break ;
				case 'C' :  nC++  ;	      	
					    break ;
	       		 }
			Longueur++ ;
		}						
	    }
	    fscanf(stdin,"%s",Seq)	;	/* lecture du #		*/
		
	    if (Longueur > 0)
	    {
		N++ ;
		fprintf(stderr,"%d\n",N) ;

		for (r = 1 ; r <= repetition ; r++)
		{
	   	    Permutte(Sequence1, Longueur, nA, nT, nG, nC) ;

				/* ecrit la nouvelle sequence	*/
	
    	    	    fprintf(stdout,"%d\n",LongSeq)                    ;

     		    if (Distingue)
			fprintf(stdout,"%d %d\n", DebPart, FinPart) ;		                 

			for (j = 1  ; j <= Longueur ; j++)
			{
			    fprintf(stdout,"%c",Sequence1[j-1])       ;
			    if ((j % NB_BASES) == 0) 
	           		fprintf(stdout,"\n") ;
			}
	
			if ((Longueur % NB_BASES) != 0) 
	        	    fprintf(stdout,"\n") ;
		
			fprintf(stdout,"#\n") ;
			 NSorties++ ;
	        }
	    }
	 }
 }

  fprintf(stderr,"nombre de sequences traitees  : %d\n",N) ;
  fprintf(stderr,"nombre de sequences en sortie : %d\n", NSorties) ;
  fprintf(stderr,"fin du programme\n") ;	
}

